apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ lookup_name }}
  name: {{ lookup_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ nextcloudlookupserver_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ lookup_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ lookup_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ lookup_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ lookup_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ lookup_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: APACHE_DOMAIN
          value: cloud-lookup.{{ root_domain }}
        - name: APACHE_HTTP_PORT
          value: "8080"
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: LOOKUP_GLOBAL_SCALE
          value: "true"
        - name: LOOKUP_JWT_KEY
          valueFrom:
            secretKeyRef:
              key: jwt-key
              name: {{ lookup_name }}
{% if nextcloudlookupserver_db_type == 'percona' %}
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ lkpc_name }}
        - name: MYSQL_HOST
          value: {{ lkpc_name }}-client
        - name: MYSQL_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ lkpc_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ lkpc_name }}
{% elif nextcloudlookupserver_db_type in [ 'mariadb', 'mysql' ] %}
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ lkms_name }}
        - name: MYSQL_HOST
          value: {{ lkms_name }}
        - name: MYSQL_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ lkms_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ lkms_name }}
{% else %}
        - name: MYSQL_PASS
          value: ""
{% endif %}
        - name: PHP_MAX_EXECUTION_TIME
          value: "{{ nextcloudlookupserver_php_max_execution_time }}"
        - name: PHP_MEMORY_LIMIT
          value: {{ nextcloudlookupserver_php_memory_limit }}
        - name: PUBLIC_PROTO
          value: https
        - name: REPLICATION_MAIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: replication-main
              name: {{ lookup_name }}
        - name: REPLICATION_PROTO
          value: http
        - name: REPLICATION_SLAVE_PASSWORD
          valueFrom:
            secretKeyRef:
              key: replication-slave
              name: {{ lookup_name }}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='nextcloudlookupserver'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='nextcloudlookupserver'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 39
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            httpHeaders:
            - name: Host
              value: cloud-lookup.{{ root_domain }}
            path: /index.html
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 30
          timeoutSeconds: 5
        name: lookup
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
              value: cloud-lookup.{{ root_domain }}
            path: /index.html
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ nextcloudlookupserver_cpu_limit }}"
            memory: "{{ nextcloudlookupserver_memory_limit }}"
          requests:
            cpu: "{{ nextcloudlookupserver_cpu_request }}"
            memory: "{{ nextcloudlookupserver_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 39
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
{% if k8s_flavor != 'openshift' and tls_provider == 'internalca' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: tmp
          subPath: apache
        - mountPath: /usr/local/share/ca-certificates
          name: tmp
          subPath: ca-certificates
        - mountPath: /usr/share/ca-certificates
          name: tmp
          subPath: empty
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 9113
{% endif %}
{% endif %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - {{ lookup_name }}
{% if do_exporters %}
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if k8s_flavor == 'kubernetes' and do_exporters %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ lookup_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if k8s_flavor != 'openshift' and tls_provider == 'internalca' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
      - emptyDir: {}
        name: tmp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='nextcloudlookupserver'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - lookup
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='nextcloudlookupserver'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
